# SPDX-License-Identifier: GPL-2.0-only
%YAML 1.2
---
$id: http://devicetree.org/schemas/clock/qcom,mmcc.yaml#
$schema: http://devicetree.org/meta-schemas/core.yaml#

title: Qualcomm Multimedia Clock & Reset Controller Binding

maintainers:
  - Jeffrey Hugo <jhugo@codeaurora.org>
  - Taniya Das <tdas@codeaurora.org>

description: |
  Qualcomm multimedia clock control module which supports the clocks, resets and
  power domains.

properties:
  compatible:
    enum:
      - qcom,mmcc-apq8064
      - qcom,mmcc-apq8084
      - qcom,mmcc-msm8660
      - qcom,mmcc-msm8960
      - qcom,mmcc-msm8974
      - qcom,mmcc-msm8996
      - qcom,mmcc-msm8998

  clocks:
    items:
      - description: Board XO source
      - description: Board sleep source
      - description: Global PLL 0 clock
      - description: DSI phy instance 0 dsi clock
      - description: DSI phy instance 0 byte clock
      - description: DSI phy instance 1 dsi clock
      - description: DSI phy instance 1 byte clock
      - description: HDMI phy PLL clock
      - description: DisplayPort phy PLL vco clock
      - description: DisplayPort phy PLL link clock

  clock-names:
    items:
      - const: xo
      - const: sleep
      - const: gpll0
      - const: dsi0dsi
      - const: dsi0byte
      - const: dsi1dsi
      - const: dsi1byte
      - const: hdmipll
      - const: dpvco
      - const: dplink

  '#clock-cells':
    const: 1

  '#reset-cells':
    const: 1

  '#power-domain-cells':
    const: 1

  reg:
    maxItems: 1

  protected-clocks:
    description:
      Protected clock specifier list as per common clock binding

  vdd-gfx-supply:
    description:
      Regulator supply for the GPU_GX GDSC

required:
  - compatible
  - reg
  - '#clock-cells'
  - '#reset-cells'
  - '#power-domain-cells'

additionalProperties: false

if:
  properties:
    compatible:
      contains:
        const: qcom,mmcc-msm8998

then:
  required:
    - clocks
    - clock-names

examples:
  # Example for MMCC for MSM8960:
  - |
    clock-controller@4000000 {
      compatible = "qcom,mmcc-msm8960";
      reg = <0x4000000 0x1000>;
      #clock-cells = <1>;
      #reset-cells = <1>;
      #power-domain-cells = <1>;
    };
...
